<?php

# Version: 1.2 -- http://www.archaicbinary.net -- Torrent Trader

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$Itemid = $params->get( 'itemid', '0' );
$torrentfolder = $params->get( 'torrentfolder', '/torrents/' );
$torrentlength = $params->get( 'torrentlength', '200' );
$fieldsize = $params->get( 'fieldsize', '30' );
$basesize = $params->get( 'basesize', '250' );
$inputfieldclass = $params->get( 'inputfieldclass', 'inputfield' );
$inputbuttonclass = $params->get( 'inputbuttonclass', 'button' );
$descrows = $params->get( 'descrows', '8' );
$desccols = $params->get( 'desccols', '5' );
$securehttp = $params->get( 'securehttp', 'http' );
$language = $params->get( 'language', 'english' );
$debugmode = $params->get( 'debugmode', '' );

# -------------> Start Class <------------- #

class file_upload {

	var $the_file;
	var $the_temp_file;
	var $upload_dir;
	var $replace;
	var $do_filename_check;
	var $max_length_filename = '$torrentlength';
	var $extensions;
	var $ext_string;
	var $language;
	var $http_error;
	var $rename_file; // if this var is true the file copy get a new name
	var $file_copy; // the new name
	var $message = array();
	var $create_directory = true;
	
	function file_upload() {
		$this->language = "en"; // choice of en, nl, es
		$this->rename_file = false;
		$this->ext_string = "";
	}
	function show_error_string() {
		$msg_string = "";
		foreach ($this->message as $value) {
			$msg_string .= $value."<br />\n";
		}
		return $msg_string;
	}
	function set_file_name($new_name = "") { // this "conversion" is used for unique/new filenames 
		if ($this->rename_file) {
			if ($this->the_file == "") return;
			$name = ($new_name == "") ? strtotime("now") : $new_name;
			sleep(3);
			$name = $name.$this->get_extension($this->the_file);
		} else {
			$name = str_replace(" ", "_", $this->the_file); // space will result in problems on linux systems
		}
		return $name;
	}
	function upload($to_name = "") {
		$new_name = $this->set_file_name($to_name);
		if ($this->check_file_name($new_name)) {
			if ($this->validateExtension()) {
				if (is_uploaded_file($this->the_temp_file)) {
					$this->file_copy = $new_name;
					if ($this->move_upload($this->the_temp_file, $this->file_copy)) {
						$this->message[] = $this->error_text($this->http_error);
						if ($this->rename_file) $this->message[] = $this->error_text(16);
						return true;
					}
				} else {
					$this->message[] = $this->error_text($this->http_error);
					return false;
				}
			} else {
				$this->show_extensions();
				$this->message[] = $this->error_text(11);
				return false;
			}
		} else {
			return false;
		}
	}
	function check_file_name($the_name) {
		if ($the_name != "") {
			if (strlen($the_name) > $this->max_length_filename) {
				$this->message[] = $this->error_text(13);
				return false;
			} else {
				if ($this->do_filename_check == "y") {
					if (preg_match("/^[a-z0-9_]*\.(.){1,5}$/i", $the_name)) {
						return true;
					} else {
						$this->message[] = $this->error_text(12);
						return false;
					}
				} else {
					return true;
				}
			}
		} else {
			$this->message[] = $this->error_text(10);
			return false;
		}
	}
	function get_extension($from_file) {
		$ext = strtolower(strrchr($from_file,"."));
		return $ext;
	}
	function validateExtension() {
		$extension = $this->get_extension($this->the_file);
		$ext_array = $this->extensions;
		if (in_array($extension, $ext_array)) { 
			// check mime type hier too against allowed/restricted mime types (boolean check mimetype)
			return true;
		} else {
			return false;
		}
	}
	// this method is only used for detailed error reporting
	function show_extensions() {
		$this->ext_string = implode(" ", $this->extensions);
	}
	function move_upload($tmp_file, $new_file) {
		if ($this->existing_file($new_file)) {
			$newfile = $this->upload_dir.$new_file;
			if ($this->check_dir($this->upload_dir)) {
				if (move_uploaded_file($tmp_file, $newfile)) {
					umask(0);
					chmod($newfile , 0644);
					return true;
				} else {
					return false;
				}
			} else {
				$this->message[] = $this->error_text(14);
				return false;
			}
		} else {
			$this->message[] = $this->error_text(15);
			return false;
		}
	}
	function check_dir($directory) {
		if (!is_dir($directory)) {
			if ($this->create_directory) {
				umask(0);
				mkdir($directory, 0777);
				return true;
			} else {
				return false;
			}
		} else {
			return true;
		}
	}
	function existing_file($file_name) {
		if ($this->replace == "y") {
			return true;
		} else {
			if (file_exists($this->upload_dir.$file_name)) {
				return false;
			} else {
				return true;
			}
		}
	}
	function get_uploaded_file_info($name) {
		$str = "File name: ".basename($name)."\n";
		$str .= "File size: ".filesize($name)." bytes\n";
		if (function_exists("mime_content_type")) {
			$str .= "Mime type: ".mime_content_type($name)."\n";
		}
		if ($img_dim = getimagesize($name)) {
			$str .= "Image dimensions: x = ".$img_dim[0]."px, y = ".$img_dim[1]."px\n";
		}
		return $str;
	}
	// this method was first located inside the foto_upload extension
	function del_temp_file($file) {
		$delete = @unlink($file); 
		clearstatcache();
		if (@file_exists($file)) { 
			$filesys = eregi_replace("/","\\",$file); 
			$delete = @system("del $filesys");
			clearstatcache();
			if (@file_exists($file)) { 
				$delete = @chmod ($file, 0644); 
				$delete = @unlink($file); 
				$delete = @system("del $filesys");
			}
		}
	}
	// this function creates a file field and if $show_alternate is true it will show a text field if the given file already exists
	// there is also a submit button to remove the text field value 
	function create_file_field($element, $label = "", $length = 25, $show_replace = true, $replace_label = "Replace old file?", $file_path = "", $file_name = "", $show_alternate = false, $alt_length = 30, $alt_btn_label = "Delete image") {
		$field = ($label != "") ? "<label>".$label."</label>\n" : "";
		$file_field = "<input type=\"file\" name=\"".$element."\" size=\"".$length."\" />\n";
		$file_field .= ($show_replace) ? "<span>".$replace_label."</span><input type=\"checkbox\" name=\"replace\" value=\"y\" />" : "";
		if ($file_name != "" && $show_alternate) {
			$field .= "<input type=\"text\" name=\"".$element."\" size=\"".$alt_length."\" value=\"".$file_name."\" readonly=\"readonly\"";
			$field .= (!@file_exists($file_path.$file_name)) ? " title=\"".sprintf($this->error_text(17), $file_name)."\" />\n" : " />\n";
			$field .= "<input type=\"checkbox\" name=\"del_img\" value=\"y\" /><span>".$alt_btn_label."</span>\n";
		} else {
			$field .= $file_field;
		} 
		return $field;
	}
	// some error (HTTP)reporting, change the messages or remove options if you like.
	function error_text($err_num) {
		switch ($this->language) {
			default:
			// start http errors
			$error[0] = "File: <b>".$this->the_file."</b> successfully uploaded!";
			$error[1] = "The uploaded file exceeds the max. upload filesize directive in the server configuration.";
			$error[2] = "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the html form.";
			$error[3] = "The uploaded file was only partially uploaded";
			$error[4] = "No file was uploaded";
			// end  http errors
			$error[10] = "Please select a file for upload.";
			$error[11] = "Only files with the following extensions are allowed: <b>".$this->ext_string."</b>";
			$error[12] = "Sorry, the filename contains invalid characters. Use only alphanumerical chars and separate parts of the name (if needed) with an underscore. <br>A valid filename ends with one dot followed by the extension.";
			$error[13] = "The filename exceeds the maximum length of ".$this->max_length_filename." characters.";
			$error[14] = "Sorry, the upload directory doesn't exist!";
			$error[15] = "Uploading <b>".$this->the_file."...Error!</b> Sorry, a file with this name already exitst.";
			$error[16] = "The uploaded file is renamed to <b>".$this->file_copy."</b>.";
			$error[17] = "The file %s does not exist.";
		}
		return $error[$err_num];
	}
}

# -------------> End Class <------------- #

$max_size = 1024*$basesize;

$my_upload = new file_upload;

$my_upload->upload_dir = $_SERVER['DOCUMENT_ROOT'] . $torrentfolder;
$my_upload->extensions = array(".torrent");
$my_upload->max_length_filename = $torrentlength;
$my_upload->rename_file = false;
		
if(isset($_POST['Submit'])){
	$my_upload->the_temp_file = $_FILES['upload']['tmp_name'];
	$my_upload->the_file = $_FILES['upload']['name'];
	$my_upload->http_error = $_FILES['upload']['error'];
	$my_upload->replace = (isset($_POST['replace'])) ? $_POST['replace'] : "n"; // because only a checked checkboxes is true
	$my_upload->do_filename_check = (isset($_POST['check'])) ? $_POST['check'] : "n"; // use this boolean to check for a valid filename
	$new_name = (isset($_POST['name'])) ? $_POST['name'] : "";
	if ($my_upload->upload($new_name)) { // new name is an additional filename information, use this to rename the uploaded file
		$full_path = $my_upload->upload_dir.$my_upload->file_copy;
		$torrentfilename = $my_upload->file_copy;
		$info = $my_upload->get_uploaded_file_info($full_path);
		$torrentcategory = $_POST['category'];
		$description = $_POST['description'];

# -------------> Start Torrent Parse <------------- #

require("components/com_torrenttrader/BDecode.php");
require("components/com_torrenttrader/BEncode.php");

$fd = fopen("$full_path", "rb");
$stream = fread($fd, filesize("$full_path"));
fclose($fd);

function getfilesize($bytes) {
	if ($bytes >= 1099511627776){
		$return = round($bytes / 1024 / 1024 / 1024 / 1024, 2);
		$suffix = "TB";
	}elseif ($bytes >= 1073741824){
		$return = round($bytes / 1024 / 1024 / 1024, 2);
		$suffix = "GB";
	}elseif ($bytes >= 1048576){
		$return = round($bytes / 1024 / 1024, 2);
		$suffix = "MB";
	}elseif ($bytes >= 1024){
		$return = round($bytes / 1024, 2);
		$suffix = "KB";
	}else{
		$return = $bytes;
		$suffix = "Byte";
	}

	if ($return == 1){
		$return .= " " . $suffix;
	}else{
		$return .= " " . $suffix . "s";
	}

	return $return;
}

function pathurlencode($uri) {
	$uri = urlencode($uri);
	$uri = str_replace('%3A', ':', $uri);
	$uri = str_replace('%2F', '/', $uri);
	$uri = str_replace('%26', '&', $uri);
	$uri = str_replace('%40', '@', $uri);
	$uri = str_replace('%3A', ':', $uri);
	$uri = str_replace('%3F', '?', $uri);
	$uri = str_replace('%3D', '=', $uri);
	$uri = str_replace('%5B', '[', $uri);
	$uri = str_replace('%5D', ']', $uri);
	return $uri;
}

function sapeerconnect($httpurl, $binsha1s, $torrentsize){
	global $seeds, $peers, $completeddl, $estbandwidth, $error;

	set_time_limit(0);

	$ch = curl_init();
	$timeout = 15;
	$curlconnection = curl_setopt ($ch, CURLOPT_URL, $httpurl);

	$stream = "";

	if ($curlconnection) {
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
			$stream = curl_exec($ch);
	}

	curl_close($ch);

	if(!$curlconnection){
		$error = "No Response From Tracker. Please Try Again Later." ;
	}else{
		$decoded = BDecode($stream);
		if ($decoded["files"] === TRUE){
			$error = "File not present on tracker (torrent may be dead).";
		}else{
			$sha1files = $decoded["files"];
			$sha1tor = $sha1files[$binsha1s];
			if(isset($sha1files[$binsha1s])){
				$seeds = $sha1tor['complete'];
				$peers = $sha1tor['incomplete'];
				if(isset($sha1tor['downloaded'])){
					$completeddl = $sha1tor['downloaded'];
					if(isset($torrentsize)){
						$bandwidth = $sha1tor['downloaded'] * $torrentsize;
						$estbandwidth = getfilesize($bandwidth);
					}
				}
			}else{
				$error = "Error with Tracker Response.";
			}
		}
	}
}

global $seeds, $peers, $completeddl, $estbandwidth, $database, $my, $error;
	
$array = BDecode($stream);

$infovariable = $array["info"];
$infohash = sha1(BEncode($infovariable));
$announce = $array["announce"];
$internalname = $infovariable['name'];
$creationdate = date('r' , $array["creation date"]);
$datenow = date("M j, Y");

$query = "SELECT id FROM #__torrenttrader_torrents ORDER BY id DESC LIMIT 1";
$database->setQuery( $query );
$rows = $database->loadObjectList();
$row = $rows[0];
$torrentid = $row->id + 1;

if (isset($array["announce-list"])){
	foreach($array["announce-list"] as $alist){
		$announcelist = $alist[0] . "**" . $announcelist;
	}
}

if (isset($infovariable["files"])){

	foreach ($infovariable["files"] as $file){
		$multiname = $file['path'];
		$multifilename = $multiname[0];
		$multitorrentsize = $file['length'];
		$multifilesize = getfilesize($multitorrentsize);
		$torrentsize += $file['length'];

		if (isset($file["ed2k"])){
			$multied2k = bin2hex($file["ed2k"]);
		}

		if (isset($file["sha1"])){
			$multisha1 = bin2hex($file["sha1"]);
		}

		if (isset($file["MD5SUM"])){
			$multimd5 = bin2hex($file["MD5SUM"]);
		}

		$database->setQuery( "INSERT INTO #__torrenttrader_files (torrentid, filename, filesize, ed2khash, sha1, md5sum) VALUES ('$torrentid', '$multifilename', '$multifilesize', '$multied2k', '$multisha1', '$multimd5')" );
		$database->query();
	}

	$torrentfilesize = getfilesize($torrentsize);

}else{
	$torrentsize = $infovariable['length'];
	$torrentfilesize = getfilesize($torrentsize);
}

$piecesize = getfilesize($infovariable['piece length']);

$urlannounce = strtolower($announce);
if (substr($urlannounce, 0, 7) === "http://"){
	if ((substr_count($urlannounce, "/announce")) == 1){
		$scrape = str_replace('/announce', '/scrape', $urlannounce);
		$httpget = "?info_hash=";
		$binsha1 = pack("H*", $infohash);
		$binsha1s = addslashes($binsha1);
		$fullurl = "$scrape$httpget$binsha1";
		$httpurl = pathurlencode($fullurl);
		sapeerconnect($httpurl, $binsha1s, $torrentsize);
	}else{
		$error = "Bad Tracker URL for scraping (Maybe Trackerless Torrent).";
	}
}else{
	$error = "Bad Tracker URL for scraping (Maybe Trackerless Torrent).";
}

$lastupdate = date("l, M j, Y g:i:s T");

$database->setQuery( "INSERT INTO #__torrenttrader_torrents (primarytracker, backuptracker, internalname, infohash, creationdate, filename, filesize, piecesize, seeds, peers, completeddl, estbandwidth, errors, category, uploadedby, uploadeddate, description, lastupdate) VALUES ('$announce', '$announcelist', '$internalname', '$infohash', '$creationdate', '$torrentfilename', '$torrentfilesize', '$piecesize', '$seeds', '$peers', '$completeddl', '$estbandwidth', '$error', '$torrentcategory', '$my->username', '$datenow', '$description', '$lastupdate')" );
$database->query();

$link = sefRelToAbs( 'index.php?option=com_torrenttrader&Itemid=' . $Itemid );
$link = ampReplace( $link );

if ($debugmode != 'yes'){
	mosRedirect( $link );
}

# -------------> End Torrent Parse <------------- #

	}
}

$link = sefRelToAbs( $securehttp . '://' . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'] );
$link = ampReplace( $link );

require("components/com_torrenttrader/language/" . $language . ".php");

?>

<form name="uploadform" enctype="multipart/form-data" method="post" action="<?php echo $link; ?>">
<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $max_size; ?>">
<label for="upload"><?php echo $_TORRENTTRADERMODULE_UPLOADTORRENT; ?>: </label><input type="file" name="upload" class="<?php echo $inputfieldclass; ?>" size="<?php echo $fieldsize; ?>">
<label for="category"><?php echo $_TORRENTTRADERMODULE_CATEGORY; ?>:<br /></label><select name="category" class="<?php echo $inputfieldclass; ?>">
<?php

$database->setQuery( "SELECT id, category FROM #__torrenttrader_cats ORDER BY category" );
$rows = $database->loadObjectList();
foreach($rows as $row){
	echo '<option name="category" value="' . $row->id . '">' . $row->category . '</option>';
}

?>
</select><br />
<?php echo $_TORRENTTRADERMODULE_DESCRIPTION; ?>:<br /><textarea name="description" rows="<?php echo $descrows; ?>" cols="<?php echo $desccols; ?>"></textarea><br />
<input type="submit" name="Submit" value="<?php echo $_TORRENTTRADERMODULE_UPLOAD; ?>" class="<?php echo $inputbuttonclass; ?>">
</form>
<p><?php echo $my_upload->show_error_string(); ?></p>